#ifndef MYGRAPHICSVIEW_H
#define MYGRAPHICSVIEW_H

#include <QGraphicsView>
#include <QGraphicsRectItem>
#include <QtWidgets>
#include <QCheckBox>
#include <QMessageBox>

typedef struct GraphTrigger
{
    char    *name;
    int     *link;
    int     x, y;
} GraphTrigger;

//Derived Class from QCheckBox
class MyCheckBox: public QCheckBox
{
  Q_OBJECT
  public:
    MyCheckBox(const QString & text, QWidget* parent, int * linkage = NULL )
    {
      trigger_link = linkage;
      this->setText( text );
      this->setParent(parent);
      connect(this , SIGNAL(stateChanged(int)),this,SLOT(checkBoxStateChanged(int)));
    };
    ~ MyCheckBox(){};

    int * trigger_link;

  public slots:
    //Slot that is called when CheckBox is checked or unchecked
    void checkBoxStateChanged(int state)
    {
        QMessageBox* msg = new QMessageBox(this->parentWidget());
        msg->setWindowTitle("Hello !");

        if(state)
        {
          msg->setText("Trigger Set !");
          *trigger_link = 1;
        }
        else
        {
          msg->setText("Trigger Clear !");
          *trigger_link = 0;
        }
        //msg->show();
    };



};

class MyGraphicsView : public QGraphicsView
{
    Q_OBJECT

public:
    MyGraphicsView(QWidget* parent = NULL);

private slots:
    void NextStepPressed ();

private:
    MyCheckBox * triggers[1000];
    int num_triggers;

protected:

    //Take over the interaction
    virtual void wheelEvent(QWheelEvent* event);
};

#endif // MYGRAPHICSVIEW_H
